diff --git a/gcc/analyzer/engine.cc b/gcc/analyzer/engine.cc
index 1e2ae2b5655..0808cadeeef 100644
--- a/gcc/analyzer/engine.cc
+++ b/gcc/analyzer/engine.cc
@@ -1632,156 +1041,24 @@ public:
    point.  */
 
 exploded_node::on_stmt_flags
-exploded_node::on_stmt (exploded_graph &eg,
-			const supernode *snode,
-			const gimple *stmt,
-			program_state *state,
-			state_change *change) const
-{
-  logger *logger = eg.get_logger ();
-  LOG_SCOPE (logger);
-  if (logger)
-    {
-      logger->start_log_line ();
-      pp_gimple_stmt_1 (logger->get_printer (), stmt, 0, (dump_flags_t)0);
-      logger->end_log_line ();
-    }
-
-  /* Update input_location in case of ICE: make it easier to track down which
-     source construct we're failing to handle.  */
-  input_location = stmt->location;
-
-  if (state->m_region_model2)
-    return on_stmt2 (eg, snode, stmt, state, change);
-
-  /* Preserve the old state.  It is used here for looking
-     up old checker states, for determining state transitions, and
-     also within impl_region_model_context and impl_sm_context for
-     going from tree to svalue_id.  */
-  const program_state old_state (*state);
-
-  impl_region_model_context ctxt (eg, this,
-				  &old_state, state, change,
-				  stmt);
-
-  if (const gassign *assign = dyn_cast <const gassign *> (stmt))
-    state->m_region_model->on_assignment (assign, &ctxt);
-
-  if (const greturn *return_ = dyn_cast <const greturn *> (stmt))
-    state->m_region_model->on_return (return_, &ctxt);
-
-  /* Track whether we have a gcall to a function that's not recognized by
-     anything, for which we don't have a function body, or for which we
-     don't know the fndecl.  */
-  bool unknown_side_effects = false;
-  if (const gcall *call = dyn_cast <const gcall *> (stmt))
-    {
-      /* Debugging/test support.  */
-      if (is_special_named_call_p (call, "__analyzer_dump", 0))
-	{
-	  /* Handle the builtin "__analyzer_dump" by dumping state
-	     to stderr.  */
-	  dump (eg.get_ext_state ());
-	}
-      else if (is_special_named_call_p (call, "__analyzer_dump_path", 0))
-	{
-	  /* Handle the builtin "__analyzer_dump_path" by queuing a
-	     diagnostic at this exploded_node.  */
-	  ctxt.warn (new dump_path_diagnostic ());
-	}
-      else if (is_special_named_call_p (call, "__analyzer_dump_region_model", 0))
-	{
-	  /* Handle the builtin "__analyzer_dump_region_model" by dumping
-	     the region model's state to stderr.  */
-	  state->m_region_model->dump (false);
-	}
-      else if (is_special_named_call_p (call, "__analyzer_eval", 1))
-	{
-	  /* Handle the builtin "__analyzer_eval" by evaluating the input
-	     and dumping as a dummy warning, so that test cases can use
-	     dg-warning to validate the result (and so unexpected warnings will
-	     lead to DejaGnu failures).  */
-	  tree t_arg = gimple_call_arg (call, 0);
-	  tristate t
-	    = state->m_region_model->eval_condition (t_arg,
-						     NE_EXPR,
-						     integer_zero_node,
-						     &ctxt);
-	  warning_at (call->location, 0, "%s", t.as_string ());
-	}
-      else if (is_special_named_call_p (call, "__analyzer_break", 0))
-	{
-	  /* Handle the builtin "__analyzer_break" by triggering a
-	     breakpoint.  */
-	  /* TODO: is there a good cross-platform way to do this?  */
-	  raise (SIGINT);
-	}
-      else if (is_special_named_call_p (call, "__analyzer_dump_exploded_nodes",
-					1))
-	{
-	  /* This is handled elsewhere.  */
-	}
-      else if (is_setjmp_call_p (call))
-	state->m_region_model->on_setjmp (call, this, &ctxt);
-      else if (is_longjmp_call_p (call))
-	{
-	  on_longjmp (eg, call, state, &ctxt);
-	  return on_stmt_flags::terminate_path ();
-	}
-      else
-	unknown_side_effects = state->m_region_model->on_call_pre (call, &ctxt);
-    }
-
-  bool any_sm_changes = false;
-  int sm_idx;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (old_state.m_checker_states, sm_idx, smap)
-    {
-      const state_machine &sm = eg.get_ext_state ().get_sm (sm_idx);
-      const sm_state_map *old_smap
-	= old_state.m_checker_states[sm_idx];
-      sm_state_map *new_smap = state->m_checker_states[sm_idx];
-      impl_sm_context sm_ctxt (eg, sm_idx, sm, this, &old_state, state,
-			       change,
-			       old_smap, new_smap);
-      /* Allow the state_machine to handle the stmt.  */
-      if (sm.on_stmt (&sm_ctxt, snode, stmt))
-	unknown_side_effects = false;
-      else
-	{
-	  /* For those stmts that were not handled by the state machine.  */
-	  if (const gcall *call = dyn_cast <const gcall *> (stmt))
-	    {
-	      tree callee_fndecl
-		= state->m_region_model->get_fndecl_for_call (call, &ctxt);
-
-	      if (!fndecl_has_gimple_body_p (callee_fndecl))
-		new_smap->purge_for_unknown_fncall (eg, sm, call, callee_fndecl,
-						    state->m_region_model,
-						    &ctxt);
-	    }
-	}
-      if (*old_smap != *new_smap)
-	any_sm_changes = true;
-    }
-
-  if (const gcall *call = dyn_cast <const gcall *> (stmt))
-    state->m_region_model->on_call_post (call, unknown_side_effects, &ctxt);
-
-  return on_stmt_flags (any_sm_changes);
-}
-
-/* Modify STATE in place, applying the effects of the stmt at this node's
-   point.  */
-
-exploded_node::on_stmt_flags
-exploded_node::on_stmt2 (exploded_graph &eg,
+exploded_node::on_stmt (exploded_graph &eg,
 			const supernode *snode,
 			const gimple *stmt,
-			program_state *state,
-			state_change *change) const
+			program_state *state) const
 {
-  // FIXME: this is for revamped states
+  logger *logger = eg.get_logger ();
+  LOG_SCOPE (logger);
+  if (logger)
+    {
+      logger->start_log_line ();
+      pp_gimple_stmt_1 (logger->get_printer (), stmt, 0, (dump_flags_t)0);
+      logger->end_log_line ();
+    }
+
+  /* Update input_location in case of ICE: make it easier to track down which
+     source construct we're failing to handle.  */
+  input_location = stmt->location;
+
   gcc_assert (state->m_region_model2);
 #if 0
     {
@@ -1799,7 +1076,7 @@ exploded_node::on_stmt2 (exploded_graph &eg,
   const program_state old_state (*state);
 
   impl_region_model2_context ctxt (eg, this,
-				   &old_state, state, change,
+				   &old_state, state,
 				   stmt);
 
   if (const gassign *assign = dyn_cast <const gassign *> (stmt))
@@ -1833,7 +1110,7 @@ exploded_node::on_stmt2 (exploded_graph &eg,
 	{
 	  /* Handle the builtin "__analyzer_dump_region_model" by dumping
 	     the region model's state to stderr.  */
-	  state->m_region_model->dump (false);
+	  state->m_region_model2->dump (false);
 	}
       else if (is_special_named_call_p (call, "__analyzer_eval", 1))
 	state->m_region_model2->impl_call_analyzer_eval (call, &ctxt);
@@ -1870,7 +1147,6 @@ exploded_node::on_stmt2 (exploded_graph &eg,
 	= old_state.m_checker_states2[sm_idx];
       sm_state_map2 *new_smap = state->m_checker_states2[sm_idx];
       impl_sm_context2 sm_ctxt (eg, sm_idx, sm, this, &old_state, state,
-				change,
 				old_smap, new_smap);
       /* Allow the state_machine to handle the stmt.  */
       if (sm.on_stmt (&sm_ctxt, snode, stmt))
@@ -1919,15 +1195,14 @@ bool
 exploded_node::on_edge (exploded_graph &eg,
 			const superedge *succ,
 			program_point *next_point,
-			program_state *next_state,
-			state_change *change) const
+			program_state *next_state) const
 {
   LOG_FUNC (eg.get_logger ());
 
   if (!next_point->on_edge (eg, succ))
     return false;
 
-  if (!next_state->on_edge (eg, *this, succ, change))
+  if (!next_state->on_edge (eg, *this, succ))
     return false;
 
   return true;
@@ -1993,119 +1268,6 @@ private:
   const gcall *m_longjmp_call;
 };
 
-/* Handle LONGJMP_CALL, a call to longjmp or siglongjmp.
-
-   Attempt to locate where setjmp/sigsetjmp was called on the jmp_buf and build
-   an exploded_node and exploded_edge to it representing a rewind to that frame,
-   handling the various kinds of failure that can occur.  */
-
-void
-exploded_node::on_longjmp (exploded_graph &eg,
-			   const gcall *longjmp_call,
-			   program_state *new_state,
-			   region_model_context *ctxt) const
-{
-  tree buf_ptr = gimple_call_arg (longjmp_call, 0);
-
-  region_model *new_region_model = new_state->m_region_model;
-  region_id buf_rid = new_region_model->deref_rvalue (buf_ptr, ctxt);
-  region *buf = new_region_model->get_region (buf_rid);
-  if (!buf)
-    return;
-
-  svalue_id buf_content_sid
-    = buf->get_value (*new_region_model, false, ctxt);
-  svalue *buf_content_sval = new_region_model->get_svalue (buf_content_sid);
-  if (!buf_content_sval)
-    return;
-  setjmp_svalue *setjmp_sval = buf_content_sval->dyn_cast_setjmp_svalue ();
-  if (!setjmp_sval)
-    return;
-
-  const setjmp_record tmp_setjmp_record = setjmp_sval->get_setjmp_record ();
-
-  /* Build a custom enode and eedge for rewinding from the longjmp/siglongjmp
-     call back to the setjmp/sigsetjmp.  */
-  rewind_info_t rewind_info (tmp_setjmp_record, longjmp_call);
-
-  const gcall *setjmp_call = rewind_info.get_setjmp_call ();
-  const program_point &setjmp_point = rewind_info.get_setjmp_point ();
-
-  const program_point &longjmp_point = get_point ();
-
-  /* Verify that the setjmp's call_stack hasn't been popped.  */
-  if (!valid_longjmp_stack_p (longjmp_point, setjmp_point))
-    {
-      ctxt->warn (new stale_jmp_buf (setjmp_call, longjmp_call));
-      return;
-    }
-
-  gcc_assert (longjmp_point.get_stack_depth ()
-	      >= setjmp_point.get_stack_depth ());
-
-  /* Update the state for use by the destination node.  */
-
-  /* Stash the current number of diagnostics so that we can update
-     any that this adds to show where the longjmp is rewinding to.  */
-
-  diagnostic_manager *dm = &eg.get_diagnostic_manager ();
-  unsigned prev_num_diagnostics = dm->get_num_diagnostics ();
-
-  new_region_model->on_longjmp (longjmp_call, setjmp_call,
-				setjmp_point.get_stack_depth (), ctxt);
-
-  program_point next_point
-    = program_point::after_supernode (setjmp_point.get_supernode (),
-				      setjmp_point.get_call_string ());
-
-  state_change change;
-  exploded_node *next
-    = eg.get_or_create_node (next_point, *new_state, this, &change);
-
-  /* Create custom exploded_edge for a longjmp.  */
-  if (next)
-    {
-      exploded_edge *eedge
-	= eg.add_edge (const_cast<exploded_node *> (this), next, NULL,
-		       change,
-		       new rewind_info_t (tmp_setjmp_record, longjmp_call));
-
-      /* For any diagnostics that were queued here (such as leaks) we want
-	 the checker_path to show the rewinding events after the "final event"
-	 so that the user sees where the longjmp is rewinding to (otherwise the
-	 path is meaningless).
-
-	 For example, we want to emit something like:
-                        |   NN | {
-                        |   NN |   longjmp (env, 1);
-                        |      |   ~~~~~~~~~~~~~~~~
-                        |      |   |
-                        |      |   (10) 'ptr' leaks here; was allocated at (7)
-                        |      |   (11) rewinding from 'longjmp' in 'inner'...
-                        |
-          <-------------+
-          |
-        'outer': event 12
-          |
-          |   NN |   i = setjmp(env);
-          |      |       ^~~~~~
-          |      |       |
-          |      |       (12) ...to 'setjmp' in 'outer' (saved at (2))
-
-	 where the "final" event above is event (10), but we want to append
-	 events (11) and (12) afterwards.
-
-	 Do this by setting m_trailing_eedge on any diagnostics that were
-	 just saved.  */
-      unsigned num_diagnostics = dm->get_num_diagnostics ();
-      for (unsigned i = prev_num_diagnostics; i < num_diagnostics; i++)
-	{
-	  saved_diagnostic *sd = dm->get_saved_diagnostic (i);
-	  sd->m_trailing_eedge = eedge;
-	}
-    }
-}
-
 /* Handle LONGJMP_CALL, a call to longjmp or siglongjmp.
 
    Attempt to locate where setjmp/sigsetjmp was called on the jmp_buf and build
@@ -2175,16 +1337,16 @@ exploded_node::on_longjmp2 (exploded_graph &eg,
     = program_point::after_supernode (setjmp_point.get_supernode (),
 				      setjmp_point.get_call_string ());
 
-  state_change change;
+  /*state_change change;*/
   exploded_node *next
-    = eg.get_or_create_node (next_point, *new_state, this, &change);
+    = eg.get_or_create_node (next_point, *new_state, this/*, &change*/);
 
   /* Create custom exploded_edge for a longjmp.  */
   if (next)
     {
       exploded_edge *eedge
 	= eg.add_edge (const_cast<exploded_node *> (this), next, NULL,
-		       change,
+		       //change,
 		       new rewind_info_t (tmp_setjmp_record, longjmp_call));
 
       /* For any diagnostics that were queued here (such as leaks) we want
@@ -2250,35 +1412,17 @@ exploded_node::detect_leaks (exploded_graph &eg) const
      what leaks (via purge_unused_svalues).  */
   program_state new_state (old_state);
 
-  if (!old_state.m_region_model)
-    {
-      gcc_assert (new_state.m_region_model2);
-
-#if 1
-      purge_stats2 stats;
-      impl_region_model2_context ctxt (eg, this,
-				       &old_state, &new_state,
-				       NULL,
-				       get_stmt ());
-      const svalue2 *result = NULL;
-      new_state.m_region_model2->pop_frame (NULL, true, &stats, &result,
-					    &ctxt);
-      program_state::detect_leaks2 (old_state, new_state, result,
-				    eg.get_ext_state (), &ctxt);
-#endif
-    }
-  else
-    {
-      gcc_assert (new_state.m_region_model);
-
-      purge_stats stats;
-      impl_region_model_context ctxt (eg, this,
-				      &old_state, &new_state,
-				      NULL,
-				      get_stmt ());
-      new_state.m_region_model->pop_frame (region_id::null (),
-					   true, &stats, &ctxt);
-    }
+  gcc_assert (new_state.m_region_model2);
+
+  purge_stats2 stats;
+  impl_region_model2_context ctxt (eg, this,
+				   &old_state, &new_state,
+				   get_stmt ());
+  const svalue2 *result = NULL;
+  new_state.m_region_model2->pop_frame (NULL, true, &stats, &result,
+					&ctxt);
+  program_state::detect_leaks2 (old_state, new_state, result,
+				eg.get_ext_state (), &ctxt);
 }
 
 /* Dump the successors and predecessors of this enode to OUTF.  */
@@ -2317,21 +1461,6 @@ exploded_node::dump_succs_and_preds (FILE *outf) const
    to a setjmp (which doesn't have a superedge, but does affect
    state).  */
 
-void
-rewind_info_t::update_model (region_model *model,
-			     const exploded_edge &eedge)
-{
-  const program_point &longjmp_point = eedge.m_src->get_point ();
-  const program_point &setjmp_point = eedge.m_dest->get_point ();
-
-  gcc_assert (longjmp_point.get_stack_depth ()
-	      >= setjmp_point.get_stack_depth ());
-
-  model->on_longjmp (get_longjmp_call (),
-		     get_setjmp_call (),
-		     setjmp_point.get_stack_depth (), NULL);
-}
-
 void
 rewind_info_t::update_model2 (region_model2 *model,
 			      const exploded_edge &eedge)
@@ -2380,12 +1509,12 @@ rewind_info_t::add_events_to_path (checker_path *emission_path,
 exploded_edge::exploded_edge (exploded_node *src, exploded_node *dest,
 			      const extrinsic_state &ext_state,
 			      const superedge *sedge,
-			      const state_change &change,
+			      //const state_change &change,
 			      custom_info_t *custom_info)
-: dedge<eg_traits> (src, dest), m_sedge (sedge), m_change (change),
+: dedge<eg_traits> (src, dest), m_sedge (sedge), /*m_change (change),*/
   m_custom_info (custom_info)
 {
-  change.validate (dest->get_state (), ext_state);
+  //change.validate (dest->get_state (), ext_state);
 }
 
 /* exploded_edge's dtor.  */
@@ -2446,7 +1575,7 @@ exploded_edge::dump_dot (graphviz_out *gv, const dump_args_t &args) const
   else if (m_custom_info)
     m_custom_info->print (pp);
 
-  m_change.dump (pp, args.m_eg.get_ext_state ());
+  //m_change.dump (pp, args.m_eg.get_ext_state ());
   //pp_write_text_as_dot_label_to_stream (pp, /*for_record=*/false);
 
   pp_printf (pp, "\"];\n");
@@ -2710,14 +1839,15 @@ worklist::key_t::cmp (const worklist::key_t &ka, const worklist::key_t &kb)
   const program_state &state_a = ka.m_enode->get_state ();
   const program_state &state_b = kb.m_enode->get_state ();
 
+#if 0
   /* Sort by sm-state, so that identical sm-states are grouped
      together in the worklist.
      For now, sort by the hash value (might not be deterministic).  */
-  for (unsigned sm_idx = 0; sm_idx < state_a.m_checker_states.length ();
+  for (unsigned sm_idx = 0; sm_idx < state_a.m_checker_states2.length ();
        ++sm_idx)
     {
-      sm_state_map *smap_a = state_a.m_checker_states[sm_idx];
-      sm_state_map *smap_b = state_b.m_checker_states[sm_idx];
+      sm_state_map2 *smap_a = state_a.m_checker_states2[sm_idx];
+      sm_state_map2 *smap_b = state_b.m_checker_states2[sm_idx];
 
       hashval_t hash_a = smap_a->hash ();
       hashval_t hash_b = smap_b->hash ();
@@ -2726,6 +1856,7 @@ worklist::key_t::cmp (const worklist::key_t &ka, const worklist::key_t &kb)
       else if (hash_a > hash_b)
 	return 1;
     }
+#endif
 
   /* Otherwise, we have two enodes at the same program point but with
      different states.  We don't have a good total ordering on states,
@@ -2752,7 +1883,7 @@ exploded_graph::exploded_graph (const supergraph &sg, logger *logger,
   m_PK_AFTER_SUPERNODE_per_snode (m_sg.num_nodes ())
 {
   m_origin = get_or_create_node (program_point::origin (),
-				 program_state (ext_state), NULL, NULL);
+				 program_state (ext_state), NULL);
   for (int i = 0; i < m_sg.num_nodes (); i++)
     m_PK_AFTER_SUPERNODE_per_snode.quick_push (i);
 }
@@ -2790,18 +1921,16 @@ exploded_graph::add_function_entry (function *fun)
   if (!state.m_valid)
     return NULL;
 
-  exploded_node *enode = get_or_create_node (point, state, NULL, NULL);
+  exploded_node *enode = get_or_create_node (point, state, NULL);
   /* We should never fail to add such a node.  */
   gcc_assert (enode);
-  state_change change;
-  add_edge (m_origin, enode, NULL, change);
+  //state_change change;
+  add_edge (m_origin, enode, NULL/*, change*/);
   return enode;
 }
 
 /* Get or create an exploded_node for (POINT, STATE).
    If a new node is created, it is added to the worklist.
-   If CHANGE is non-NULL, use it to suppress some purging of state,
-   to make generation of state_change_event instances easier.
 
    FIXME: ENODE_FOR_DIAG: we pass this in so that we can emit
    diagnostics when purging state *before* we have a new enode;
@@ -2816,7 +1945,6 @@ exploded_node *
 exploded_graph::get_or_create_node (const program_point &point,
 				    const program_state &state,
 				    const exploded_node *enode_for_diag,
-				    state_change *change,
 				    bool is_split)
 {
   logger * const logger = get_logger ();
@@ -2853,7 +1981,7 @@ exploded_graph::get_or_create_node (const program_point &point,
   /* Prune state to try to improve the chances of a cache hit,
      avoiding generating redundant nodes.  */
   program_state pruned_state
-    = state.prune_for_point (*this, point, enode_for_diag, change);
+    = state.prune_for_point (*this, point, enode_for_diag);
 
   pruned_state.validate (get_ext_state ());
 
@@ -2866,8 +1994,8 @@ exploded_graph::get_or_create_node (const program_point &point,
       pp_string (pp, "pruned_state: ");
       pruned_state.dump_to_pp (m_ext_state, true, false, pp);
       logger->end_log_line ();
-      if (pruned_state.m_region_model)
-	pruned_state.m_region_model->dump_to_pp (logger->get_printer (), true);
+      pruned_state.m_region_model2->dump_to_pp (logger->get_printer (), true,
+						false);
     }
 
   stats *per_fn_stats = get_or_create_function_stats (point.get_function ());
@@ -2920,8 +2048,6 @@ exploded_graph::get_or_create_node (const program_point &point,
 		 relationship to those of the input state, and thus to those
 		 of CHANGE, so we must purge any svalue_ids from *CHANGE.  */
 	      ps.set_state (merged_state);
-	      if (change)
-		change->on_svalue_purge (svalue_id::from_int (0));
 
 	      if (exploded_node **slot = m_point_and_state_to_node.get (&ps))
 		{
@@ -3024,11 +2150,11 @@ exploded_graph::get_or_create_node (const program_point &point,
 exploded_edge *
 exploded_graph::add_edge (exploded_node *src, exploded_node *dest,
 			  const superedge *sedge,
-			  const state_change &change,
+			  //const state_change &change,
 			  exploded_edge::custom_info_t *custom_info)
 {
   exploded_edge *e = new exploded_edge (src, dest, m_ext_state,
-					sedge, change, custom_info);
+					sedge, /*change, */custom_info);
   digraph<eg_traits>::add_edge (e);
 
 #if 0
@@ -3244,7 +2370,6 @@ exploded_graph::process_worklist ()
 		gcc_assert (state != state_2);
 
 		program_state merged_state (m_ext_state);
-		state_change change;
 		if (state.can_merge_with_p (state_2, m_ext_state,
 					    point, &merged_state))
 		  {
@@ -3255,7 +2380,7 @@ exploded_graph::process_worklist ()
 		    if (merged_state == state)
 		      {
 			/* Then merge node_2 into node by adding an edge.  */
-			add_edge (node_2, node, NULL, change);
+			add_edge (node_2, node, NULL);
 
 			/* Remove node_2 from the worklist.  */
 			m_worklist.take_next ();
@@ -3268,7 +2393,7 @@ exploded_graph::process_worklist ()
 			/* Then merge node into node_2, and leave node_2
 			   in the worklist, to be processed on the next
 			   iteration.  */
-			add_edge (node, node_2, NULL, change);
+			add_edge (node, node_2, NULL);
 			node->set_status (exploded_node::STATUS_MERGER);
 			continue;
 		      }
@@ -3284,7 +2409,7 @@ exploded_graph::process_worklist ()
 			   states, adding to the worklist.  */
 			exploded_node *merged_enode
 			  = get_or_create_node (node->get_point (),
-						merged_state, node, &change);
+						merged_state, node);
 			if (merged_enode == NULL)
 			  continue;
 
@@ -3313,7 +2438,7 @@ exploded_graph::process_worklist ()
 			  m_worklist.add_node (merged_enode);
 			else
 			  {
-			    add_edge (node, merged_enode, NULL, change);
+			    add_edge (node, merged_enode, NULL);
 			    node->set_status (exploded_node::STATUS_MERGER);
 			  }
 
@@ -3321,7 +2446,7 @@ exploded_graph::process_worklist ()
 			  m_worklist.add_node (merged_enode);
 			else
 			  {
-			    add_edge (node_2, merged_enode, NULL, change);
+			    add_edge (node_2, merged_enode, NULL);
 			    node_2->set_status (exploded_node::STATUS_MERGER);
 			  }
 
@@ -3441,24 +2566,15 @@ exploded_graph::process_node (exploded_node *node)
     case PK_BEFORE_SUPERNODE:
       {
 	program_state next_state (state);
-	state_change change;
+	//state_change change;
 
 	if (point.get_from_edge ())
 	  {
-	    impl_region_model_context ctxt (*this, node,
-					    &state, &next_state, &change,
-					    NULL);
 	    impl_region_model2_context ctxt2 (*this, node,
-					      &state, &next_state, &change,
-					      NULL);
+					      &state, &next_state, NULL);
 	    const cfg_superedge *last_cfg_superedge
 	      = point.get_from_edge ()->dyn_cast_cfg_superedge ();
-	    if (last_cfg_superedge && next_state.m_region_model)
-	      next_state.m_region_model->update_for_phis
-		(node->get_supernode (),
-		 last_cfg_superedge,
-		 &ctxt);
-	    if (last_cfg_superedge && next_state.m_region_model2)
+	    if (last_cfg_superedge)
 	      next_state.m_region_model2->update_for_phis
 		(node->get_supernode (),
 		 last_cfg_superedge,
@@ -3471,9 +2587,9 @@ exploded_graph::process_node (exploded_node *node)
 	      = program_point::before_stmt (point.get_supernode (), 0,
 					    point.get_call_string ());
 	    exploded_node *next
-	      = get_or_create_node (next_point, next_state, node, &change);
+	      = get_or_create_node (next_point, next_state, node);
 	    if (next)
-	      add_edge (node, next, NULL, change);
+	      add_edge (node, next, NULL);
 	  }
 	else
 	  {
@@ -3481,9 +2597,9 @@ exploded_graph::process_node (exploded_node *node)
 	      = program_point::after_supernode (point.get_supernode (),
 						point.get_call_string ());
 	    exploded_node *next = get_or_create_node (next_point, next_state,
-						      node, &change);
+						      node);
 	    if (next)
-	      add_edge (node, next, NULL, change);
+	      add_edge (node, next, NULL);
 	  }
       }
       break;
@@ -3509,7 +2625,6 @@ exploded_graph::process_node (exploded_node *node)
 	   the sm-state-change occurs on an edge where the src enode has
 	   exactly one stmt, the one that caused the change. */
 	program_state next_state (state);
-	state_change change;
 	const supernode *snode = point.get_supernode ();
 	unsigned stmt_idx;
 	const gimple *prev_stmt = NULL;
@@ -3531,7 +2646,7 @@ exploded_graph::process_node (exploded_node *node)
 
 	    /* Process the stmt.  */
 	    exploded_node::on_stmt_flags flags
-	      = node->on_stmt (*this, snode, stmt, &next_state, &change);
+	      = node->on_stmt (*this, snode, stmt, &next_state);
 	    node->m_num_processed_stmts++;
 
 	    /* If flags.m_terminate_path, stop analyzing; any nodes/edges
@@ -3542,8 +2657,7 @@ exploded_graph::process_node (exploded_node *node)
 	    if (next_state.m_region_model2)
 	      {
 		impl_region_model2_context ctxt (*this, node,
-						 &old_state, &next_state, &change,
-						 stmt);
+						 &old_state, &next_state, stmt);
 		program_state::detect_leaks2 (old_state, next_state, NULL,
 					      get_ext_state (), &ctxt);
 	      }
@@ -3555,8 +2669,7 @@ exploded_graph::process_node (exploded_node *node)
 					       point.get_call_string ())
 		 : program_point::after_supernode (point.get_supernode (),
 						   point.get_call_string ()));
-	    next_state
-	      = next_state.prune_for_point (*this, next_point, node, &change);
+	    next_state = next_state.prune_for_point (*this, next_point, node);
 
 	    if (flags.m_sm_changes || flag_analyzer_fine_grained)
 	      {
@@ -3574,11 +2687,10 @@ exploded_graph::process_node (exploded_node *node)
 		       and any state change will effectively occur on that
 		       latter edge, and split_enode will contain just stmt.  */
 		    exploded_node *split_enode
-		      = get_or_create_node (split_point, old_state, node, NULL,
-					    true);
+		      = get_or_create_node (split_point, old_state, node, true);
 		    if (!split_enode)
 		      return;
-		    add_edge (node, split_enode, NULL, change);
+		    add_edge (node, split_enode, NULL);
 		    node = split_enode;
 		    break;
 		  }
@@ -3594,10 +2706,9 @@ exploded_graph::process_node (exploded_node *node)
 					   point.get_call_string ())
 	     : program_point::after_supernode (point.get_supernode (),
 					       point.get_call_string ()));
-	exploded_node *next = get_or_create_node (next_point, next_state,
-						  node, &change);
+	exploded_node *next = get_or_create_node (next_point, next_state, node);
 	if (next)
-	  add_edge (node, next, NULL, change);
+	  add_edge (node, next, NULL);
       }
       break;
     case PK_AFTER_SUPERNODE:
@@ -3637,14 +2748,12 @@ exploded_graph::process_node (exploded_node *node)
 	      logger->log ("considering SN: %i -> SN: %i",
 			   succ->m_src->m_index, succ->m_dest->m_index);
 
-	    state_change change;
-
 	    program_point next_point
 	      = program_point::before_supernode (succ->m_dest, succ,
 						 point.get_call_string ());
 	    program_state next_state (state);
 
-	    if (!node->on_edge (*this, succ, &next_point, &next_state, &change))
+	    if (!node->on_edge (*this, succ, &next_point, &next_state))
 	      {
 		if (logger)
 		  logger->log ("skipping impossible edge to SN: %i",
@@ -3653,9 +2762,9 @@ exploded_graph::process_node (exploded_node *node)
 	      }
 
 	    exploded_node *next = get_or_create_node (next_point, next_state,
-						      node, &change);
+						      node);
 	    if (next)
-	      add_edge (node, next, succ, change);
+	      add_edge (node, next, succ);
 	  }
       }
       break;
@@ -3897,126 +3006,6 @@ exploded_path::get_final_enode () const
   return m_edges[m_edges.length () - 1]->m_dest;
 }
 
-/* Check state along this path, returning true if it is feasible.
-   If OUT is non-NULL, and the path is infeasible, write a new
-   feasibility_problem to *OUT.  */
-
-bool
-exploded_path::feasible_p (logger *logger, feasibility_problem **out) const
-{
-  LOG_SCOPE (logger);
-
-  /* Traverse the path, updating this model.  */
-  region_model model;
-  for (unsigned edge_idx = 0; edge_idx < m_edges.length (); edge_idx++)
-    {
-      const exploded_edge *eedge = m_edges[edge_idx];
-      if (logger)
-	logger->log ("considering edge %i: EN:%i -> EN:%i",
-		     edge_idx,
-		     eedge->m_src->m_index,
-		     eedge->m_dest->m_index);
-      const exploded_node &src_enode = *eedge->m_src;
-      const program_point &src_point = src_enode.get_point ();
-      if (logger)
-	{
-	  logger->start_log_line ();
-	  src_point.print (logger->get_printer (), format (false));
-	  logger->end_log_line ();
-	}
-
-      /* Update state for the stmts that were processed in each enode.  */
-      for (unsigned stmt_idx = 0; stmt_idx < src_enode.m_num_processed_stmts;
-	   stmt_idx++)
-	{
-	  const gimple *stmt = src_enode.get_processed_stmt (stmt_idx);
-
-	  /* Update cfun and input_location in case of ICE: make it easier to
-	     track down which source construct we're failing to handle.  */
-	  auto_cfun sentinel (src_point.get_function ());
-	  input_location = stmt->location;
-
-	  if (const gassign *assign = dyn_cast <const gassign *> (stmt))
-	    model.on_assignment (assign, NULL);
-	  else if (const greturn *return_ = dyn_cast <const greturn *> (stmt))
-	    model.on_return (return_, NULL);
-	}
-
-      const superedge *sedge = eedge->m_sedge;
-      if (sedge)
-	{
-	  if (logger)
-	    logger->log ("  sedge: SN:%i -> SN:%i %s",
-			 sedge->m_src->m_index,
-			 sedge->m_dest->m_index,
-			 sedge->get_description (false));
-
-	  const gimple *last_stmt = src_point.get_supernode ()->get_last_stmt ();
-	  if (!model.maybe_update_for_edge (*sedge, last_stmt, NULL))
-	    {
-	      if (logger)
-		{
-		  logger->log ("rejecting due to region model");
-		  model.dump_to_pp (logger->get_printer (), false);
-		}
-	      if (out)
-		*out = new feasibility_problem (edge_idx, model, *eedge,
-						last_stmt);
-	      return false;
-	    }
-	}
-      else
-	{
-	  /* Special-case the initial eedge from the origin node to the
-	     initial function by pushing a frame for it.  */
-	  if (edge_idx == 0)
-	    {
-	      gcc_assert (eedge->m_src->m_index == 0);
-	      gcc_assert (src_point.get_kind () == PK_ORIGIN);
-	      gcc_assert (eedge->m_dest->get_point ().get_kind ()
-			  == PK_BEFORE_SUPERNODE);
-	      function *fun = eedge->m_dest->get_function ();
-	      gcc_assert (fun);
-	      model.push_frame (fun, NULL, NULL);
-	      if (logger)
-		logger->log ("  pushing frame for %qD", fun->decl);
-	    }
-	  else if (eedge->m_custom_info)
-	    eedge->m_custom_info->update_model (&model, *eedge);
-	}
-
-      /* Handle phi nodes on an edge leaving a PK_BEFORE_SUPERNODE (to
-	 a PK_BEFORE_STMT, or a PK_AFTER_SUPERNODE if no stmts).
-	 This will typically not be associated with a superedge.  */
-      if (src_point.get_from_edge ())
-	{
-	  const cfg_superedge *last_cfg_superedge
-	    = src_point.get_from_edge ()->dyn_cast_cfg_superedge ();
-	  if (last_cfg_superedge)
-	    {
-	      if (logger)
-		logger->log ("  update for phis");
-	      model.update_for_phis (src_enode.get_supernode (),
-				     last_cfg_superedge,
-				     NULL);
-	    }
-	}
-
-      if (logger)
-	{
-	  logger->log ("state after edge %i: EN:%i -> EN:%i",
-		       edge_idx,
-		       eedge->m_src->m_index,
-		       eedge->m_dest->m_index);
-	  logger->start_log_line ();
-	  model.dump_to_pp (logger->get_printer (), true);
-	  logger->end_log_line ();
-	}
-    }
-
-  return true;
-}
-
 /* Check state along this path, returning true if it is feasible.
    If OUT is non-NULL, and the path is infeasible, write a new
    feasibility_problem to *OUT.  */
